unit Unit1;
{$H-}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons, ComDrv32;


type
   fchar=file of char;
   ptext=text;

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    ProgressBar2: TProgressBar;
    GroupBox2: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    GroupBox3: TGroupBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    GroupBox4: TGroupBox;
    Button9: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    CommPortDriver1: TCommPortDriver;
    ComboBox1: TComboBox;
    Timer1: TTimer;
    Button2: TButton;
    Button10: TButton;
    procedure przegladaj(Sender: TObject);
    procedure czytaj_flash(Sender: TObject);
    procedure zaawansowane(Sender: TObject);
    procedure sprawdz(Sender: TObject);
    procedure czytaj_eeprom(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure formCreate(Sender: TObject);
    procedure prog_flash(Sender: TObject);
    procedure weryf_flash(Sender: TObject);
    procedure prog_eeprom(Sender: TObject);
    procedure weryf_eeprom(Sender: TObject);
    procedure odswierz(Sender: TObject);

  
    procedure FormClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
    procedure Byte_2_INTEL_HEX(var streamm,streamf:Tmemorystream);
    procedure INTEL_HEX_2_BYTE  (var streamm,streamf:tmemorystream;var komunikat:string);
    function ostrzezenie(cojest:string):boolean;
    function file_exists(fname:string):boolean;
    function JestProg(kcom:byte):boolean;
    procedure INTEL_HEX_2_CHIP (var streamm:tmemorystream;flash,byte_mode:boolean);
    function weryfikacja(var streamm:Tmemorystream;flash,byte_mode:boolean):boolean;
    procedure zczytaj(var streamm:Tmemorystream;flash,byte_mode:boolean);
  public

    { Public declarations }
  end;


var
  Form1       : TForm1;
  File_name   : string;
  Flash_Size  : Word;
  EEprom_Size : Word;
  kod_procesora:byte;
  prog_byte   : boolean; {true bajtowe , false slowne}
  rom,intel_hex         : TmemoryStream;
  select                :integer;
  f1,debug    : text;
  adres_max   :word;
  demo        :boolean;


const
  odzew = 'AVR ISP';

implementation
 uses unit2,unit3, Unit4;
{$R *.DFM}

  procedure tform1.Byte_2_INTEL_HEX(var streamm,streamf:Tmemorystream);
 {zamienia bajty ze strumienia binary na format Intel hex}
var
  i,j,k:integer;
  crc: integer;
  intelhex:string[128];
  bajt: byte;
begin
  streamm.position:=0;
  for j:=0 to (streamm.size div 16-1) do
  begin
    intelhex:='';
    intelhex:= intelhex+':10'+inttohex(16*j,4)+'00';
    crc:=hi(16*j)+lo(16*j)+16;
    for i:=1 to 16 do
    begin
      streamm.read(bajt,1);

      intelhex:=intelhex+inttohex(bajt,2);
      crc:=(crc + bajt)mod 256;
      if crc=0 then crc:=256;
    end;
    intelhex:=intelhex+inttohex(256-crc,2)+char(13)+char(10);
    k:= length(intelhex);
    for i:=1 to k do
    streamf.write(intelhex[i],1);
  end;
  //linia niepena
  intelhex:='';

  k:= streamm.size mod 16 ;
  if k<>0 then
  begin
  crc:=hi(16*j)+lo(16*j)+k;
  intelhex:= intelhex + ':'+inttohex(k,2)+inttohex(16*j,4)+'00';
    for i:=1 to k do
    begin
      streamm.read(bajt,1);
      intelhex:=intelhex+inttohex(bajt,2);
      crc:=(crc + bajt)mod 256;
      if crc=0 then crc:=256;
    end;
    intelhex:=intelhex+inttohex(256-crc,2)+char(13)+char(10);
    k:= length(intelhex);
    for i:=1 to k do
    streamf.write(intelhex[i],1);
    end;
  intelhex:=':00000001FF'+char(13)+char(10);
  k:= length(intelhex);
  for i:=1 to k do
    streamf.write(intelhex[i],1);


  end ;

   function tform1.weryfikacja(var streamm:Tmemorystream;flash,byte_mode:boolean):boolean;

var
  adres:integer;
  bajt: array[1..2] of char;
  ch1,ch2: char;
  error: boolean;
begin
  error:=false;
  streamm.position:=0;
  commportdriver1.sendchar('P');
  repeat until CommPortDriver1.ReadChar(ch1);
  if flash then
     begin
      adres:=0;
     if byte_mode then begin

         repeat
           streamm.read(bajt[1],1);
            commportdriver1.sendchar('A');
          commportdriver1.sendchar(char(hi(adres)));
          commportdriver1.sendchar(char(lo(adres)));
          repeat until commportdriver1.readchar(ch1);
          inc(adres);
           commportdriver1.sendchar('R');
           repeat  until CommPortDriver1.ReadChar(ch1);
           if ch1<>bajt[1] then error:=true;
           form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);
        until (streamm.position>=streamm.size) or error;
        end
        else
           repeat
            inc(adres);
           streamm.read(bajt,2);
           commportdriver1.sendchar('R');
           repeat  until CommPortDriver1.ReadChar(ch1);
           repeat  until CommPortDriver1.ReadChar(ch2);

           if (ch2<>bajt[1]) then error:=true;
           if ch1<>bajt[2] then error:=true ;


          form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);

           until (streamm.position>=streamm.size) or error;
        end
  else
      repeat
        streamm.read(bajt[1],1);
        commportdriver1.sendchar('d');
        repeat  until CommPortDriver1.ReadChar(ch1);
        if ch1<>bajt[1] then error:=true;
         form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);
        until (streamm.position>=streamm.size) or error;

        weryfikacja:= not error;
        if error then begin
        form1.ProgressBar2.Position:=2;
        form1.label2.caption:=inttostr(adres);
        end;
      end ;

 procedure tform1.zczytaj(var streamm:Tmemorystream;flash,byte_mode:boolean);
 {czyta flash lub eeprom na strumie streamm}
var

  i:integer;
  ch1,ch2: char;

begin

  streamm.position:=0;
  commportdriver1.sendchar('P');
  repeat until CommPortDriver1.ReadChar(ch1);
  if flash then
     begin
     if byte_mode then
        for i:=0 to flash_size-1 do
        begin
           form1.ProgressBar2.Position:=round(i/flash_size*100);
             commportdriver1.sendchar('A');
          commportdriver1.sendchar(char(hi(i)));
          commportdriver1.sendchar(char(lo(i)));
          repeat until commportdriver1.readchar(ch1);
           commportdriver1.sendchar('R');
           repeat  until CommPortDriver1.ReadChar(ch1);
           streamm.write(ch1,1);
        end
        else
           for i:=1 to flash_size do //w sowach
            begin

           form1.ProgressBar2.Position:=round(i/flash_size*100);
           commportdriver1.sendchar('R');
           repeat  until CommPortDriver1.ReadChar(ch1);
           repeat  until CommPortDriver1.ReadChar(ch2);
           streamm.write(ch2,1);
           streamm.write(ch1,1);
           end;
        end
  else
      for i:=1 to eeprom_size do
         begin
        form1.ProgressBar2.Position:=round(i/eeprom_size*100);
        commportdriver1.sendchar('d');
        repeat  until CommPortDriver1.ReadChar(ch1);
        streamm.write(ch1,1);
        end;
   commportdriver1.sendchar('L');
  end ;

procedure Tform1.INTEL_HEX_2_BYTE (var streamm,streamf:tmemorystream;var komunikat:string);
{zamienia strumie obraz pliku  Intel Hex streamm na strumie bin streamf}
var
 	i,j,k:integer; {numer znaku}
	liczba_danych:integer;{liczba danych w linii}
        error:boolean;
        rozkaz:byte;
        adres:word;
        ch:char;
        crc,crc_i:integer;
        line_size_max: integer;
        numer_linii:integer;
        last_address        :integer;
begin
     error:=false;
     Komunikat:='Konwersja OK';
     streamm.position:=0;
     streamf.position:=0;
      numer_linii:=0;
     line_size_max:=0;
     last_address:=0;
     repeat         //pocztek przetwarzania linii
     inc(numer_linii);
       crc:=0;
       crc_i:=0;
       k:=0;        //licznik bajtw w linii
        adres:=0;
       liczba_danych:=0;
       streamm.read(ch,1);
       inc(k);
       if ch=':' then
         begin          //1


            for i:=2 to 3 do {liczba danych znak 2 i 3}
                        begin //2
                        streamm.read(ch,1);
                        inc(k);
                        case upcase(ch) of    //4
	                 '0'..'9': liczba_danych:=liczba_danych*16+ord(ch)-48;	{kod '0'}
	                 'A'..'F': liczba_danych:=liczba_danych*16+ord(ch)-65+10;	{kod 'A'+10}
                  	else
	                    begin //3
	                     komunikat:='Nieprawidowy format Intel HEX - znak w polu 2-3';
	                     error:=true;
                            end; //3
                         end; //4

                         end;//2
                         crc:=crc+liczba_danych;
            for i:=4 to 7 do {adres cztery znaki }
                         begin//5
                         streamm.read(ch,1);
                         inc(k);
                         case upcase(ch) of
	                         '0'..'9': adres:=adres*16+ord(ch)-48;	{kod '0'}
	                         'A'..'F': adres:=adres*16+ord(ch)-65+10;{kod 'A'+10}
                         else	error:=true;
                                 komunikat:='Nieprawidowy format Intel HEX 2 - adres';
                         end;
                         end;//5
            crc:=crc+hi(adres)+lo(adres);
            if last_address<adres then //wypenianie bajtami $FF pustki
               begin
               rozkaz:=255;
               for j:= last_address to adres-1 do
                streamf.Write(rozkaz,1)
               end;
            streamm.read(ch,1);
            inc(k);
            if ch='0' then
             begin//6
               streamm.read(ch,1);
               inc(k);
               case upcase(ch) of
                    '1':   //rekord kocowy zczytaj dwa znaki CRC
                    begin
                            crc:=1;
                          //streamm.read(ch,1);

                          //streamm.read(ch,1);
                    end ;
                    '2': //rozszerzenie adresu
                         begin//17
                         
                         for i:=1 to liczba_danych do
                             begin //18
                                  rozkaz:=0;
                                  for j:=1 to 2 do
                                      begin//9
                                        streamm.read(ch,1);
                                        inc(k);
		                  	case upcase(ch) of
		                 	'0'..'9': rozkaz:=rozkaz*16+ord(ch)-48;	{kod '0'}
		                 	'A'..'F': rozkaz:=rozkaz*16+ord(ch)-65+10;	{kod 'A'+10}
		                 	else	error:=true; komunikat:='Nieprawidowy format Intel HEX - pole danych'
       		                 	end;
                                        end;//9
                                  //s to najstarsze dwa bajty adresu
                                  //dla mikrokontrolerw ola

                                  crc:=crc+rozkaz;
                             end;//18
                             crc:=crc+2;
                         end;//17
                    '0': begin//7
                         for i:=1 to liczba_danych do
                             begin //8
                                  rozkaz:=0;
                                  for j:=1 to 2 do
                                      begin//9
                                        streamm.read(ch,1);
                                        inc(k);
		                  	case upcase(ch) of
		                 	'0'..'9': rozkaz:=rozkaz*16+ord(ch)-48;	{kod '0'}
		                 	'A'..'F': rozkaz:=rozkaz*16+ord(ch)-65+10;	{kod 'A'+10}
		                 	else	error:=true; komunikat:='Nieprawidowy format Intel HEX - pole danych'
       		                 	end;
                                        end;//9
                                  streamf.Write(rozkaz,1);
                                  adres:=adres+1;
                                  crc:=crc+rozkaz;
                             end;//8
                         end;//7
                    else
                         komunikat:='Nieprawidowy format Intel HEX 4';;
		                         error:=true
                    end //case
              end//6
            else
            begin
            komunikat:='Nieprawidowy format Intel HEX1 ';
	                          error:=true
            end;//if

         //tu dwa znaki CRC
            for j:=1 to 2 do
             begin//9
             streamm.read(ch,1);
             inc(k);
             case upcase(ch) of
             '0'..'9': crc_i:=crc_i*16+ord(ch)-48;	{kod '0'}
             'A'..'F': crc_i:=crc_i*16+ord(ch)-65+10;	{kod 'A'+10}
             else	error:=true; komunikat:='Nieprawidowy format Intel HEX - pole CRC'
             end;
             end;//9
             crc:=crc mod 256;
             if crc=0 then crc:=256;
             crc:=256-crc;
             if crc<>crc_i then
             komunikat:= 'CRC error linia '+inttostr(numer_linii)+' '+ inttostr(crc) +' '+ inttostr(crc_i);
             //#CR #LF naley zdj
              streamm.read(ch,1);
             inc(k);
             if ch<>char(13) then
              begin
                   komunikat:='Nieprawidowy format Intel HEX - CR ';
                   error:=true;
            end;//if
              streamm.read(ch,1);
             inc(k);
             if ch<>char(10) then
              begin
                   komunikat:='Nieprawidowy format Intel HEX - LF ';
                   error:=true;
                   end;
             if k>line_size_max then
                line_size_max:=k;
         end //1
         else
         begin
         komunikat:='Nieprawidowy format Intel HEX - :';
         error:=true;
         end;

         last_address:=adres;
       until    (streamm.position>=streamm.size) or error ;

end;{procedure Intel_hex_2_byte}



  procedure Tform1.INTEL_HEX_2_CHIP (var streamm:tmemorystream;flash,byte_mode:boolean);

var
  adres:integer;
  bajt: array[1..2] of char;
  ch,ch1: char;

begin
   streamm.position:=0;
   //commportdriver1.sendchar('P');
   //repeat until CommPortDriver1.ReadChar(ch1);
   if flash then
     begin    //1
      adres:=0;
        if byte_mode then begin //2
          repeat
           streamm.read(bajt[1],1);
           commportdriver1.sendchar('A');
           commportdriver1.sendchar(char(hi(adres)));
           commportdriver1.sendchar(char(lo(adres)));
           repeat until commportdriver1.readchar(ch1);
           inc(adres);
           commportdriver1.sendchar('c');
           commportdriver1.sendchar(char(bajt[1]));
           repeat until commportdriver1.readchar(ch);
           form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);
          until (streamm.position>=streamm.size) ;
        end    //2
          else
           repeat

             commportdriver1.sendchar('A');
           commportdriver1.sendchar(char(hi(adres)));
           commportdriver1.sendchar(char(lo(adres)));
           repeat until commportdriver1.readchar(ch1);
             streamm.read(bajt,2);
             commportdriver1.sendchar('c');
             commportdriver1.sendchar(char(bajt[1]));
             repeat until commportdriver1.readchar(ch);
             commportdriver1.sendchar('C');
             commportdriver1.sendchar(char(bajt[2]));
             repeat until commportdriver1.readchar(ch);
              inc(adres);
             form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);
           until (streamm.position>=streamm.size)
        end//1
  else
      repeat
        streamm.read(bajt[1],1);
        commportdriver1.sendchar('D');
        commportdriver1.sendchar(bajt[1]);
        repeat  until CommPortDriver1.ReadChar(ch1);
        form1.ProgressBar2.Position:=round(streamm.position/streamm.size*100);
      until (streamm.position>=streamm.size)
         
      end ;



function Tform1.file_exists(fname:string):boolean;
var
  czy:boolean;
  f1:file;
begin
  czy:=true;
  assignfile(f1,fname);
  {$I-}
  reset(f1);
  {$I+}
  if ioresult <> 0 then
   czy:=false
   else
   closefile(f1);
  file_exists:=czy;
end;

function tform1.ostrzezenie(cojest:string):boolean;
begin

  //form3.button1.visible:=false;

  form3.label1.caption:=cojest;
  form3.show;
  ostrzezenie:=odpowiedz;
end;

procedure TForm1.przegladaj(Sender: TObject);
var

  s1:string;
begin

  OpenDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
  OpenDialog1.Execute;
  File_Name:=OpenDialog1.FileName;
  Label1.Caption:=File_Name;
  if file_name<>'' then
  begin
  intel_hex:=Tmemorystream.create;
  rom:=Tmemorystream.create;
  intel_hex.loadfromfile(file_name);
  intel_hex_2_byte(intel_hex,rom,s1);
  //komunikat w s1
  intel_hex.free;
  rom.free;
  if s1<>'Konwersja OK' then ostrzezenie(s1) ;
  end;
end;

procedure TForm1.czytaj_flash(Sender: TObject);

begin
//  rom.free;
  SaveDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
  savedialog1.filename:='';
  SaveDialog1.Execute;


  if savedialog1.filename<>'' then
  begin
    File_Name:=SaveDialog1.FileName;
    Label1.Caption:=File_Name;
    form1.timer1.interval:=2000;
    form1.timer1.enabled:=true;
    select:=0;

  end ;





end;

procedure TForm1.zaawansowane(Sender: TObject);
var
  c: char;
  bity :byte;
  i:integer;

  str1,str2,str3:string;
begin
     bity:=255;
     fuse:=255;
     if not demo then begin
  // wyslij P , odbierz x i olej , s odbierz 3 bajty , sygnatura
  // wyslij F , odbierz bajt zinterpretuj go ( bity ) ,
  // wyslij L
  while commportdriver1.readchar(c) do ;//wyczy
  //c:=char(kod_procesora);
  //CommPortDriver1.SendChar('T');
  //CommPortDriver1.SendChar('c');
   CommPortDriver1.SendChar('S');
   while commportdriver1.readchar(c) do ;//wyczy;
   CommPortDriver1.SendChar('V');
   while commportdriver1.readchar(c) do ;//wyczy;
  CommPortDriver1.SendChar('P');
  repeat until CommPortDriver1.ReadChar(c);

  CommPortDriver1.SendChar('s');    //pytanie o sygnatur
  i:=0;
  repeat i:=i+1; until (CommPortDriver1.ReadChar(c)or (i>32));
  b1:=ord(c);
  i:=0;
  repeat i:=i+1; until (CommPortDriver1.ReadChar(c)or (i>32));
  b2:=ord(c);
   i:=0;
  repeat i:=i+1; until (CommPortDriver1.ReadChar(c)or (i>32));
  b3:=ord(c);
   str1:=intToHex(b3,2);
  str2:=intTohex(b2,2);
  str3:=inttohex(b1,2);
  form2.label6.caption:=str1+' '+str2+' '+str3+' ';
  CommPortDriver1.SendChar('F'); // pytanie o Bity i FUSY
    CommPortDriver1.ReadByte(bity);
   //tu dekodowanie
   case kod_procesora of
   12: begin bity:=255;fuse:=255;end;   //seria 89C5x i mae
   $086: //89S8252
          begin
          if ((bity and 1)<>1) then  begin form2.checkbox2.checked:= true; fuse:=254; end
          else begin form2.checkbox2.checked:= false ;fuse:=255 end;
          if ((bity and 224)=0) then  form2.mode.itemindex:= 3;
          if ((bity and 224)=32) then  form2.mode.itemindex:= 2;
          if ((bity and 224)=96) then  form2.mode.itemindex:= 1;
          if ((bity and 224)=224) then  form2.mode.itemindex:= 0;

          end
        else   // AVRy
          begin
               if ((bity and 1)=0) then  begin form2.checkbox1.checked:= true; fuse:=fuse and 254 end else begin form2.checkbox1.checked:=false;fuse:=fuse or 1 end;
               if ((bity and 32)=0) then begin form2.checkbox2.checked:= true;fuse:=fuse and 255-32 end else begin form2.checkbox2.checked:= false;fuse:=fuse or 32 end;
               if ((bity and 192)=0) then  form2.mode.itemindex:= 2;
               if ((bity and 192)=64) then  form2.mode.itemindex:= 1;
               if ((bity and 192)=192) then  form2.mode.itemindex:= 0;
         end;

   end;

   CommPortDriver1.SendChar('V');//pytanie o wersj programu
   str1:='Soft. ';
  repeat until CommPortDriver1.ReadChar(c);
  str1:=str1+c+'.';
  repeat until CommPortDriver1.ReadChar(c);
  str1:=str1+c;
   CommPortDriver1.SendChar('v');//pytanie o hardware
  repeat until CommPortDriver1.ReadChar(c);
  str1:=str1+' Hard. '+c;
  repeat until CommPortDriver1.ReadChar(c);
  str1:=str1+'.'+c;
  form2.softhard.caption:=str1;
   CommPortDriver1.SendChar('p');//identyfikator
  repeat until CommPortDriver1.ReadChar(c);
    if c='S' then
       begin
            form2.target.caption:='Tryb ISP';
            form2.checkbox1.enabled:=false;
            form2.checkbox2.enabled:=false;
       end;
    if c='P' then
       begin
           form2.target.caption:='Tryb PAR16';
           form2.checkbox1.enabled:=true;
           form2.checkbox2.enabled:=true;
           end;
    if (c='S') and (kod_procesora=12) then
     begin
     form2.target.caption:='Tryb PAR8';
     form2.checkbox1.enabled:=false;
     form2.checkbox2.enabled:=false;
     end;
    CommPortDriver1.SendChar('L');
    end; //koniec if demo
    form2.modechange(sender);
    Form2.Show;
end;

function Tform1.JestProg(kcom:byte):boolean;
const
  odzew='AVR ISP';
var
  smiec:string[7];
  ch:char;
begin
  // com1
  case kcom of
   1:Form1.CommPortDriver1.ComPort:=pnCOM1;
   2:Form1.CommPortDriver1.ComPort:=pnCOM2;
   3:Form1.CommPortDriver1.ComPort:=pnCOM3;
   4:Form1.CommPortDriver1.ComPort:=pnCOM4;
  end;
  smiec:='';
  Form1.CommPortDriver1.Connect;
  Form1.CommPortDriver1.SendChar('S');
    while Form1.CommPortDriver1.ReadChar(ch) do
   smiec:=smiec+ch;
  if smiec=odzew then
   jestprog:=true
  else
   jestprog:=false;
  Form1.CommPortDriver1.Disconnect;
end;

procedure Tform1.sprawdz(sender: Tobject);
var
  i,j :integer;
  ch:string;
  zn:boolean;
begin
 zn:=false;
 form3.show;
  for i:= 1 to 4 do
   if JestProg(i) then
    begin
     str(i,ch);
     form3.label1.caption:='Znaleziono programator na com'+ch;
     zn:=true;
     j:=i;
     form3.Button1.enabled:=true;
    end;

  if not zn then
  begin
    niema:=true;
    form3.label1.caption:='Nie znaleziono programatora - tryb demo';
     form3.Button1.enabled:=true;
  end
  else
  begin
  case j of
    1:CommPortDriver1.ComPort:=pnCom1;
    2:CommPortDriver1.ComPort:=pncom2;
    3:CommPortDriver1.ComPort:=pncom3;
    4:CommPortDriver1.ComPort:=pncom4;
  end;
  CommPortDriver1.Connect;
  end;
end;

procedure TForm1.czytaj_EEprom(Sender: TObject);
begin
if eeprom_size<>0 then
   begin
  rom.free;
  SaveDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
  SaveDialog1.Execute;
  File_Name:=SaveDialog1.FileName;
  Label1.Caption:=File_Name;
  form1.timer1.interval:=2000;
    form1.timer1.enabled:=true;
    select:=1;     

    end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 {
  case ostrzezenie('Plik juz xxx istnieje. Nadpisac?') of
    true: speedButton1.Caption:='1';
    false:speedButton1.Caption:='0';
  end;
  }
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var konfiguracja:ptext;
begin
     //rom.free;
  CommPortDriver1.Disconnect;
  if file_name<>''then
  begin
  assignfile(konfiguracja,'c:\P200.cf');
  rewrite(konfiguracja);
  write(konfiguracja,char(combobox1.itemindex));
  write(konfiguracja,char(form2.mode.itemindex));
  write(konfiguracja,file_name);
  closefile(konfiguracja);
  end;
end;




procedure tform1.prog_flash(Sender: TObject);


begin
 if file_name='' then
     begin
     OpenDialog1.FileName:='';
     OpenDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
     OpenDialog1.Execute;
     if OpenDialog1.FileName<>'' then
      begin
     File_Name:=OpenDialog1.FileName;
       Label1.Caption:=File_Name;
       end;
       end;
       if form2.kasowanie.checked=true then
       label2.Caption:='Kasowanie'
       else label2.Caption:=' ';
       label3.caption:='Programowanie';
       label4.caption:='Weryfikacja';
       form1.timer1.interval:=2000;
       form1.timer1.enabled:=true;
       select:=4;


   end ;

   

procedure TForm1.weryf_flash(Sender: TObject);




begin
if file_name='' then
   begin
        OpenDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
        OpenDialog1.Execute;
        File_Name:=OpenDialog1.FileName;
        Label1.Caption:=File_Name;
   end;
   if file_name<>'' then
      begin
      label4.caption:='Weryfikacja';
      form1.timer1.interval:=2000;
      form1.timer1.enabled:=true;
      select:=2;
      end;
end;
procedure Tform1.prog_eeprom(Sender: TObject);

begin
 if file_name='' then
     begin
     OpenDialog1.FileName:='';
     OpenDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
     OpenDialog1.Execute;
     if OpenDialog1.FileName<>'' then
      begin
     File_Name:=OpenDialog1.FileName;
       Label1.Caption:=File_Name;
       end;
       end;
      
      
       label3.caption:='Programowanie';
       label4.caption:='Weryfikacja';
       form1.timer1.interval:=2000;
       form1.timer1.enabled:=true;
       select:=5;


   end ;
   



procedure TForm1.weryf_EEprom(Sender: TObject);

begin
if file_name='' then
   begin
        OpenDialog1.Filter:='Pliki hex (*.hex,*.eep) |*.hex;*.eep|';
        OpenDialog1.Execute;
        File_Name:=OpenDialog1.FileName;
        Label1.Caption:=File_Name;
   end;
   if file_name<>'' then
      begin
           label4.caption:='Weryfikacja';
           form1.timer1.interval:=2000;
           form1.timer1.enabled:=true;
           select:=3;
      end;
end;

procedure TForm1.odswierz(Sender: TObject);
var
s1:string;
begin

intel_hex:=Tmemorystream.create;
  rom:=Tmemorystream.create;
  intel_hex.loadfromfile(file_name);
  intel_hex_2_byte(intel_hex,rom,s1);
  //komunikat w s1
  intel_hex.free
end;

procedure Tform1.formCreate(Sender:Tobject);

begin
    form1.timer1.interval:=2000;
    form1.timer1.enabled:=true;
    select:=6;
    demo:=false;
//end;}
end;




procedure TForm1.FormClick(Sender: TObject);
begin
form1.ProgressBar2.position:=0
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin

  case ComboBox1.Itemindex of
   0:begin Flash_Size:=2048; EEprom_Size:=0; prog_byte:=true;
   kod_procesora:=12; groupbox3.enabled:=false; form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2","Tryb 3"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:='' end;
   1:begin Flash_Size:=4096; EEprom_Size:=0; prog_byte:=true;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2","Tryb 3"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:=''end;
   2:begin Flash_Size:=20480; EEprom_Size:=0; prog_byte:=true;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2","Tryb 3"';
    form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:=''end;
   3:begin Flash_size:=512; EEprom_Size:=0; prog_byte:=false;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:='' end;
   4:begin Flash_size:=1024; EEprom_Size:=0; prog_byte:=false;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:='' end;
   5:begin Flash_Size:=2048; EEprom_Size:=0; prog_byte:=false;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:='' end;
   6:begin Flash_size:=4096; EEprom_Size:=256;prog_byte:=true ;
   kod_procesora:=$086 ;groupbox3.enabled:=true;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2","Tryb 3"';
   form2.CheckBox1.Caption:='';form2.CheckBox2.Caption:='Programowanie SPI (SPIEN)' end;
   7:begin Flash_size:=12288; EEprom_Size:=0; prog_byte:=true;
   kod_procesora:=12;groupbox3.enabled:=false;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2","Tryb 3"';
   form2.CheckBox1.Caption:=' ';form2.CheckBox2.Caption:=' ' end;
   8:begin Flash_Size:=512; EEprom_Size:=64; prog_byte:=false;
   kod_procesora:=$013; groupbox3.enabled:=true;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
   form2.CheckBox1.Caption:='Wewntrzny oscylator (RCEN)';form2.CheckBox2.Caption:='Programowanie SPI (SPIEN)'end;
   9:begin Flash_Size:=1024; EEprom_Size:=128; prog_byte:=false;
   kod_procesora:=$020;groupbox3.enabled:=true;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
   form2.CheckBox1.Caption:='Szybki start (FSTRT)';form2.CheckBox2.Caption:='Programowanie SPI (SPIEN)'end;
  10:begin Flash_Size:=2048; EEprom_Size:=256; prog_byte:=false;
  kod_procesora:=$028;groupbox3.enabled:=true;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
  form2.CheckBox1.Caption:='Szybki start (FSTRT)';form2.CheckBox2.Caption:='Programowanie SPI (SPIEN)'end;
  11:begin Flash_Size:=4096; EEprom_Size:=512; prog_byte:=false;
  kod_procesora:=$038;groupbox3.enabled:=true;form2.mode.items.commatext:='"Tryb 0","Tryb 1","Tryb 2"';
  form2.CheckBox1.Caption:='Szybki start (FSTRT)';form2.CheckBox2.Caption:='Programowanie SPI (SPIEN)'end;

  end;
  form2.mode.itemindex:=0;
{
0.AT89C51
1.AT89C52
2.AT89C55
3.AT89C1051
4.AT89C2051
5.AT89C4051
6.AT89S8252
7.AT89S53
8.AT90S1200C/D/E
9.AT90S2313
10.AT90S4414/4434
11.AT90S8515/8535}

end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
s1: string;
ch: char;

konfiguracja         :ptext;

begin

timer1.enabled:=false;
form1.enabled:=false;
case select  of
   0:begin
   if not demo then begin
           rom:=Tmemorystream.create;  //zczytaj flash do rom
           intel_hex:=Tmemorystream.create;
           zczytaj(rom,true,prog_byte);
           byte_2_intel_hex(rom,intel_hex);
           intel_hex.savetofile(File_name);
           intel_hex.free;
           end;
           end;
   1:begin
           if not demo then begin
           rom:=Tmemorystream.create;  //zczytaj eeprom do rom
           zczytaj(rom,false,true);
           intel_hex:=Tmemorystream.create;
           byte_2_intel_hex(rom,intel_hex);
           intel_hex.savetofile(File_name);
           intel_hex.free;
           end;
         end;

   2:begin
          if not demo then begin //weryfikuj flash
           intel_hex:=Tmemorystream.create;
           rom:=Tmemorystream.create;
           intel_hex.loadfromfile(file_name);
           intel_hex_2_byte(intel_hex,rom,s1);
            if s1<>'Konwersja OK' then ostrzezenie(s1)
           else begin
           intel_hex.position:=0;
           while commportdriver1.readchar(ch) do ;//wyczy
           CommPortDriver1.SendChar('P');
           repeat until CommPortDriver1.ReadChar(ch);
           CommPortDriver1.SendChar('T');
           CommPortDriver1.SendChar(char(kod_procesora));
           repeat until CommPortDriver1.ReadChar(ch);
             //weryfikuj
           if weryfikacja(rom,true,prog_byte) then ostrzezenie('Weryfikacja OK!')
           else
           ostrzezenie('Bd weryfikacji');
           CommPortDriver1.SendChar('L');
           repeat until CommPortDriver1.ReadChar(ch);
           end; //hex ok
           intel_hex.free;
           rom.Free;
            end;
            end;
   3:begin
          if not demo then begin//weryfikuj eeprom
           intel_hex:=Tmemorystream.create;
           rom:=Tmemorystream.create;
           intel_hex.loadfromfile(file_name);
           intel_hex_2_byte(intel_hex,rom,s1);
            if s1<>'Konwersja OK' then ostrzezenie(s1)
           else begin
           intel_hex:=Tmemorystream.create;
           intel_hex.position:=0;
           while commportdriver1.readchar(ch) do ;//wyczy
           CommPortDriver1.SendChar('P');
           repeat until CommPortDriver1.ReadChar(ch);
           CommPortDriver1.SendChar('T');
           CommPortDriver1.SendChar(char(kod_procesora));
           repeat until CommPortDriver1.ReadChar(ch);
             //weryfikuj
           if weryfikacja(rom,false,prog_byte) then ostrzezenie('Weryfikacja OK!')
           else
           ostrzezenie('Bd weryfikacji');
           CommPortDriver1.SendChar('L');
           repeat until CommPortDriver1.ReadChar(ch);
           end;//hex ok
           intel_hex.free;
           rom.Free;
           end;
            end;
   4:begin
          if not demo then begin//programowanie flasha
            
            intel_hex:=Tmemorystream.create;
           rom:=Tmemorystream.create;
           intel_hex.loadfromfile(file_name);
           intel_hex_2_byte(intel_hex,rom,s1);
           if s1<>'Konwersja OK' then ostrzezenie(s1)
           else begin
           //komunikat w s1
            intel_hex.position:=0;
             while commportdriver1.readchar(ch) do ;//wyczy
              CommPortDriver1.SendChar('T');
             CommPortDriver1.SendChar(char(kod_procesora));
             repeat until CommPortDriver1.ReadChar(ch);
             CommPortDriver1.SendChar('P');
             repeat until CommPortDriver1.ReadChar(ch);
             if form2.kasowanie.checked then
             begin
             CommPortDriver1.SendChar('e');
             repeat until CommPortDriver1.ReadChar(ch);
             CommPortDriver1.SendChar('L');
             repeat until CommPortDriver1.ReadChar(ch);
             CommPortDriver1.SendChar('P');
             repeat until CommPortDriver1.ReadChar(ch);
               end;
              //programuj
              //label3.Caption:='Programowanie';
             intel_hex_2_chip(rom,true,prog_byte);
              progressbar2.position:=0;
              //weryfikuj
              //label4.Caption:= 'Weryfikacja';
              if weryfikacja(rom,true,prog_byte) then ostrzezenie('Weryfikacja OK!')
                  else
                   ostrzezenie('Bd weryfikacji');
            CommPortDriver1.SendChar('L');
           repeat until CommPortDriver1.ReadChar(ch);
           end; // hex ok
            intel_hex.free;
            rom.Free;
            end;
            end;
   5:begin
          if not demo then begin//prog eeprom
          intel_hex:=Tmemorystream.create;
          rom:=Tmemorystream.create;
          intel_hex.loadfromfile(file_name);
          intel_hex_2_byte(intel_hex,rom,s1);
          //komunikat w s1
           if s1<>'Konwersja OK' then ostrzezenie(s1)
           else begin
          intel_hex.position:=0;
          while commportdriver1.readchar(ch) do ;//wyczy
          CommPortDriver1.SendChar('P');
          repeat until CommPortDriver1.ReadChar(ch);
          //CommPortDriver1.SendChar('e');
          //repeat until CommPortDriver1.ReadChar(ch);
          CommPortDriver1.SendChar('T');
          CommPortDriver1.SendChar(char(kod_procesora));
          repeat until CommPortDriver1.ReadChar(ch);
              //programuj
          intel_hex_2_chip(rom,false,prog_byte);
              //weryfikuj
          if weryfikacja(rom,false,prog_byte) then ostrzezenie('Weryfikacja OK!')
                  else
                   ostrzezenie('Bd weryfikacji');
                   CommPortDriver1.SendChar('L');
           repeat until CommPortDriver1.ReadChar(ch);
           end; //hex ok
            intel_hex.free;
            rom.free;
            end;
            end;

 6: begin    // szukanie programatora
    sprawdz(sender);
     if file_exists('c:\P200.cf') then
begin
assignfile(konfiguracja,'c:\P200.cf');
{openfile(konfiguracja);  }
reset(konfiguracja);
read(konfiguracja,ch);
form1.combobox1.itemindex:=ord(ch);
 ComboBox1Change(Sender);
read(konfiguracja,ch);
form2.mode.itemindex:=ord(ch);
 Form2.modeChange(Sender);
 read(konfiguracja,file_name);
 label1.caption:=file_name;
closefile(konfiguracja);
end
else
begin
 Flash_size:=2048;
EEprom_Size:=0;
prog_byte:=false;
   kod_procesora:=12;groupbox3.enabled:=false;
   combobox1.text:='AT89C2051';
   end;
    end;
 7:  begin   // kasowanie progresbaru i napisw
    form1.progressbar2.position:=0;
    form1.Label2.Caption:='';
    form1.Label3.Caption:='';
    form1.Label4.Caption:='';
    end;
end;
if form1.progressbar2.position<>0 then
  begin
  form1.timer1.interval:=2000;
  form1.timer1.enabled:=true;
  select:=7
  end;
  form1.enabled:=true;
  end;
procedure TForm1.Button2Click(Sender: TObject);
begin
  Form4.show;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Close;
end;

end.
